//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Diagnostics;

namespace CustomCounter
{
	/// <summary>
	/// Summary description for CustomCounterMain.
	/// </summary>
	class CustomCounterMain
	{
		static void Main(string[] args)
		{
			CounterCreationDataCollection CounterDatas = new CounterCreationDataCollection();
			// Create the counters and set their properties.
			CounterCreationData cdCounter = new CounterCreationData();
			cdCounter.CounterName = "Count";
			cdCounter.CounterHelp = "Simple counter";
			cdCounter.CounterType = PerformanceCounterType.NumberOfItems32;
			// Add counter to the collection.
			CounterDatas.Add(cdCounter);
			// Create the category and pass the collection to it.
			PerformanceCounterCategory.Create("Hello World",
                                              "Hello World performance category",
				                              CounterDatas);
		}
	}
}
