//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Threading;

namespace ProfilingSamples
{
	public class ContentionMain 
	{
		static Random r;
		private void WorkerThread()
		{
			Monitor.Enter(this);
			Thread.Sleep(r.Next(1000));
			Monitor.Exit(this);
		}
		private void TestThread()
		{
			try
			{
				while(true)
				{ 
					Thread [] t = new Thread[10];
					for(int i = 0;i < 10;i++)
					{
						t[i] = new Thread(new ThreadStart(WorkerThread));
						t[i].Start();
					}
					for(int i = 0;i < 10;i++)
					{
						t[i].Join();
					}
					Thread.Sleep(5000);
				}
			}
			catch(Exception e)
			{
				Console.WriteLine("TestThread aborting: {0}", e.Message);
			}
		}
		static void Main(string [] args)
		{
			r = new Random();
			ContentionMain m = new ContentionMain();
			Thread testThread = new Thread(new ThreadStart(m.TestThread));
			testThread.Start();
			string input = Console.ReadLine();
			testThread.Abort();
			testThread.Join();
		}
	}
}