//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
/***************************************************************************************
 * Copyright (c) 1998 Microsoft Corporation.  All Rights Reserved.
 *
 * File:
 *  basehlp.h
 *
 * Description:
 *	
 *
 *
 ***************************************************************************************/
#ifndef __REGUTIL_H__
#define __REGUTIL_H__


/***************************************************************************************
 ********************                                               ********************
 ********************           BaseException Declaration           ********************
 ********************                                               ********************
 ***************************************************************************************/
#define NumItems( s ) (sizeof( s ) / sizeof( s[0] ))


class REGUTIL
{
	public:

		static BOOL SetKeyAndValue( const char *szKey,     
		    						const char *szSubkey,  
		    						const char *szValue ); 

		static BOOL DeleteKey( const char *szKey,		
		    				   const char *szSubkey );  

		static BOOL SetRegValue( const char *szKeyName,	
		    					 const char *szKeyword, 
		    					 const char *szValue ); 

		static HRESULT RegisterCOMClass( REFCLSID rclsid,  				
								         const char *szDesc,    		
								         const char *szProgIDPrefix,
								         int iVersion,  
								         const char *szClassProgID, 	
								         const char *szThreadingModel, 
								         const char *szModule );       

		static HRESULT UnregisterCOMClass( REFCLSID rclsid,            
									       const char *szProgIDPrefix, 
									       int iVersion,               
									       const char *szClassProgID );

		static HRESULT FakeCoCreateInstance( REFCLSID rclsid, 
											 REFIID riid, 
											 void** ppv );
		

	private:

		static HRESULT _RegisterClassBase( REFCLSID rclsid,          
								           const char *szDesc,       
								           const char *szProgID,     
								           const char *szIndepProgID,
								           char *szOutCLSID );       

		static HRESULT _UnregisterClassBase( REFCLSID rclsid,            
						 			         const char *szProgID,       
									         const char *szIndepProgID,  
									         char *szOutCLSID );          

}; // REGUTIL

#endif // __REGUTIL_H__

// End of File
