//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Threading;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;

namespace RemotingSamples
{
	public class Client
	{
		public static int Main(string [] args)
		{
			try
			{
				TcpChannel chan = new TcpChannel();
				ChannelServices.RegisterChannel(chan);
				HelloServer obj = (HelloServer)Activator.GetObject(typeof(RemotingSamples.HelloServer),
					"tcp://localhost:8085/SayHello");
				while(true)
				{
					Console.WriteLine(obj.HelloMethod("The client says hello."));
					Thread.Sleep(500);
				}
			}
			catch(Exception e)
			{
				System.Console.WriteLine("Could not locate server");
				Console.WriteLine(e);
			} 
			return 0;
		}
	}
}

// If the server is not started:
// Unhandled Exception: System.Net.Sockets.SocketException: No connection could be
// made because the target machine actively refused it
//
//ServerStackTrace:
//   at System.Net.Sockets.Socket.Connect(EndPoint remoteEP)
//   at System.Runtime.Remoting.Channels.RemoteConnection.CreateNewSocket()
//   at System.Runtime.Remoting.Channels.RemoteConnection.GetSocket()
//   at System.Runtime.Remoting.Channels.SocketCache.GetSocket(String machineAndPort)
//   at System.Runtime.Remoting.Channels.Tcp.TcpClientTransportSink.SendRequestWithRetry(IMessage msg, ITransportHeaders requestHeaders, Stream requestStream)
//   at System.Runtime.Remoting.Channels.Tcp.TcpClientTransportSink.ProcessMessage(IMessage msg, ITransportHeaders requestHeaders, Stream requestStream, ITransportHeaders& responseHeaders, Stream& responseStream)
//   at System.Runtime.Remoting.Channels.BinaryClientFormatterSink.SyncProcessMessage(IMessage msg)
//
//Exception rethrown at [0]:
//   at System.Runtime.Remoting.Proxies.RealProxy.HandleReturnMessage(IMessage reqMsg, IMessage retMsg)
//   at System.Runtime.Remoting.Proxies.RealProxy.PrivateInvoke(MessageData& msgData, Int32 type)
//   at RemotingSamples.HelloServer.HelloMethod(String name) in C:\Program Files\Microsoft.NET\FrameworkSDK\Samples\quickstart\howto\samples\remoting\hello\cs\object.cs:line 14
//   at RemotingSamples.Client.Main(String[] args) in C:\Program Files\Microsoft.NET\FrameworkSDK\Samples\quickstart\howto\samples\remoting\hello\cs\client.cs:line 15